> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Retrieve an Instance Type

GET https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/instance/type/{instanceTypeId}

Get an Instance Type by ID.

If the org has an Infrastructure Provider entity that owns the Instance Type, then the Instance Type detail is returned. User must have `FORGE_PROVIDER_ADMIN` role.

If the org has a Tenant entity and it has a Tenant Account with the Infrastructure Provider of the Instance Type, then the Instance Type detail is returned. User must have `FORGE_TENANT_ADMIN` role.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/instance-type/get-instance-type

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/instance/type/{instanceTypeId}:
    get:
      operationId: get-instance-type
      summary: Retrieve an Instance Type
      description: >-
        Get an Instance Type by ID.


        If the org has an Infrastructure Provider entity that owns the Instance
        Type, then the Instance Type detail is returned. User must have
        `FORGE_PROVIDER_ADMIN` role.


        If the org has a Tenant entity and it has a Tenant Account with the
        Infrastructure Provider of the Instance Type, then the Instance Type
        detail is returned. User must have `FORGE_TENANT_ADMIN` role.
      tags:
        - subpackage_instanceType
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: instanceTypeId
          in: path
          required: true
          schema:
            type: string
        - name: includeMachineAssociation
          in: query
          description: >-
            Include Machine associations for each Instance Type. Can only be
            requested by Provider
          required: false
          schema:
            type: boolean
        - name: includeAllocationStats
          in: query
          description: Include Allocation stats. Currently can only be requested by Tenant
          required: false
          schema:
            type: boolean
        - name: includeRelation
          in: query
          description: Related entity to expand
          required: false
          schema:
            $ref: >-
              #/components/schemas/V2OrgOrgCarbideInstanceTypeInstanceTypeIdGetParametersIncludeRelation
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InstanceType'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    V2OrgOrgCarbideInstanceTypeInstanceTypeIdGetParametersIncludeRelation:
      type: string
      enum:
        - InfrastructureProvider
        - Site
      title: V2OrgOrgCarbideInstanceTypeInstanceTypeIdGetParametersIncludeRelation
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    MachineCapabilityType:
      type: string
      enum:
        - CPU
        - Memory
        - Storage
        - Network
        - GPU
        - InfiniBand
        - DPU
      description: Type of the Capability
      title: MachineCapabilityType
    MachineCapability:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/MachineCapabilityType'
          description: Type of the Capability
        name:
          type: string
          description: Name of the Capability component
        frequency:
          type:
            - string
            - 'null'
          description: Frequency of the Capability component, if available
        cores:
          type:
            - integer
            - 'null'
          description: Number of Cores in the Capability component, if applicable
        threads:
          type:
            - integer
            - 'null'
          description: Number of Threads in the Capability component, if applicable
        capacity:
          type:
            - string
            - 'null'
          description: Capacity of the Capability component, if applicable
        vendor:
          type:
            - string
            - 'null'
          description: Vendor of the Capability component, if available
        inactiveDevices:
          type: array
          items:
            type: integer
          description: A list of inactive devices
        count:
          type:
            - integer
            - 'null'
          description: Count of the Capability component
        deviceType:
          type:
            - string
            - 'null'
          description: Device Type of the Capability component, if available
      description: Describes capabilities of a Machine
      title: MachineCapability
    Deprecation:
      type: object
      properties:
        attribute:
          type:
            - string
            - 'null'
        queryParam:
          type:
            - string
            - 'null'
        endpoint:
          type:
            - string
            - 'null'
        replacedBy:
          type:
            - string
            - 'null'
        takeActionBy:
          type: string
          format: date-time
        notice:
          type: string
      description: Details of a particular deprecation in NCX Infra Controller API
      title: Deprecation
    MachineInstanceType:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: >-
            Deprecated: Use `machineId` when identifying a Machine/Instance Type
            association. This field will be removed on July 9th, 2026 0:00 UTC.
        machineId:
          type: string
        instanceTypeId:
          type: string
          format: uuid
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Associates a machine with an Instance Type
      title: MachineInstanceType
    InstanceTypeAllocationStats:
      type: object
      properties:
        assigned:
          type: integer
          description: Total number of Machines assigned to this Instance Type
        total:
          type: integer
          description: >-
            Total number of Machines allocated to different Tenants for this
            Instance Type
        used:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type currently
            being used by Tenants
        unused:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type that is
            currently not being used by Tenants
        unusedUsable:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type that is
            currently not in use but in Ready state, therefore can be
            provisioned by Tenant
        maxAllocatable:
          type: integer
          description: >-
            Maximum number of Machines of this Instance Type that can be
            allocated to a Tenant
      description: Allocation statistics for Instance Type
      title: InstanceTypeAllocationStats
    InstanceTypeStatus:
      type: string
      enum:
        - Pending
        - Registering
        - Ready
        - Deleting
        - Error
      description: Status values for Instance Type objects
      title: InstanceTypeStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type: string
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    InstanceType:
      type: object
      properties:
        id:
          type: string
          format: uuid
        name:
          type: string
        description:
          type: string
        controllerMachineType:
          type: string
        infrastructureProviderId:
          type: string
          format: uuid
        siteId:
          type: string
          format: uuid
        labels:
          $ref: '#/components/schemas/Labels'
        machineCapabilities:
          type: array
          items:
            $ref: '#/components/schemas/MachineCapability'
        machineInstanceTypes:
          type: array
          items:
            $ref: '#/components/schemas/MachineInstanceType'
          description: Available only for Providers
        allocationStats:
          $ref: '#/components/schemas/InstanceTypeAllocationStats'
          description: summary of machine counts by allocation status
        status:
          $ref: '#/components/schemas/InstanceTypeStatus'
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Instance types describe a set of machines that match a certain criteria
      title: InstanceType
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python example-1
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type/instanceTypeId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```